/*
  CPP_CONTEST=2017ClaA
  CPP_PROBLEM=B
  CPP_LANG=CPP+MPI
  CPP_PROCESSES_PER_NODE=1
  CPP_NUM_NODES=1
*/

// 12

#include <stdlib.h>
#include <stdio.h>
#include <mpi.h>
#include <iostream>
#include <iomanip>    
#include <math.h>

using namespace std;

void updateone(int n,float *vi,float *vf,long pos)
{
  vf[pos]=vi[pos];
  int ld=(int) (fabs(vi[pos])/100)+2;
  for(int i=pos+ld;i<n;i+=ld)
    vf[pos]+=vi[i];
  for(int i=pos-ld;i>=0;i-=ld)
    vf[pos]+=vi[i];
}
 
void update(int n,float *vi,float *vf)
{
  for(int i=0;i<n;i++)
    updateone(n,vi,vf,i); //update one position
}

void  sec(int n,float *v,int s,int np,int node)
{
  float *vi,*vf,*vt,*vaux; //temporal vectors

  vi=v;
  vaux=new float[n];
  vf=vaux;

  for(int i=0;i<s;i++) //s steps are carried out
  {
    update(n,vi,vf); //the vector is updated and the result is in vf
    //vf and vi are swapped
    vt=vi;
    vi=vf;
    vf=vt;
  }
  if(vi!=v)
  {
    for(long i=0;i<n;i++) //the result is copied to the vector
      v[i]=vi[i];
  }
  delete[] vaux;
}

