/*
  CPP_CONTEST=2017ClaA
  CPP_PROBLEM=C
  CPP_LANG=CUDA
  CPP_PROCESSES_PER_NODE=1
  CPP_NUM_NODES=1
*/

// 10

#include <stdlib.h>
#include <stdio.h>
#include <iostream>
#include <iomanip>    
#include <math.h>
//#include <helper_functions.h>
//#include <helper_cuda.h>

using namespace std;

#ifdef DEBUGSEC
extern void escribir(int,float*);
#endif

void updateone(int n,float *vi,float *vf,long pos)
{
  vf[pos]=vi[pos];
  int ld=(int) (fabs(vi[pos])/100)+2;
  for(int i=pos+ld;i<n;i+=ld)
    vf[pos]+=vi[i];
  for(int i=pos-ld;i>=0;i-=ld)
    vf[pos]+=vi[i];
#ifdef DEBUGSEC
    cout << "Updated position " << pos << " inside updateone. Vector ";
    escribir(n,vf);
#endif
}
 
void update(int n,float *vi,float *vf)
{
#ifdef DEBUGSEC
    cout << " Inside update. Vector ";
    escribir(n,vi);
#endif
  for(int i=0;i<n;i++)
    updateone(n,vi,vf,i); //update one position
#ifdef DEBUGSEC
    cout << " Inside update. Vector ";
    escribir(n,vf);
#endif
}

void  sec(int n,float *v,int s)
{
  float *vi,*vf,*vt,*vaux; //temporal vectors

  vi=v;
  vaux=new float[n];
  vf=vaux;

#ifdef DEBUGSEC
    cout << "Inside sec ";
    escribir(n,v);
#endif

  for(int i=0;i<s;i++) //s steps are carried out
  {
    update(n,vi,vf); //the vector is updated and the result is in vf
#ifdef DEBUGSEC
    cout << "Step " << i << " Vector ";
    escribir(n,vf);
#endif
    //vf and vi are swapped
    vt=vi;
    vi=vf;
    vf=vt;
  }
  if(vi!=v)
  {
    for(long i=0;i<n;i++) //the result is copied to the vector
      v[i]=vi[i];
  }
#ifdef DEBUGSEC
    cout << "Final vector before exiting sec ";
    escribir(n,v);
#endif
  delete[] vaux;
}

