/*
  CPP_CONTEST=2017ClaA
  CPP_PROBLEM=D
  CPP_LANG=XEONPHI
  CPP_PROCESSES_PER_NODE=1
  CPP_NUM_NODES=1
*/

// 8

#include <stdlib.h>
#include <stdio.h>
#include <omp.h>
#include <iostream>
#include <iomanip>    
#include <math.h>
//#include <omp.h>

using namespace std;

#ifdef DEBUGSEC
extern void escribir(int,float*);
#endif

void  sec(int n,float *v,int s)
{
  float *vi,*vf; //temporal vectors
  vi=new float[n];
  vf=new float[n];
  for(int i=0;i<n;i++)
    vi[i]=v[i];

  int pos;
  for(int i=0;i<n;i++)
    vf[i]=0;
//  omp_set_num_threads(1);//Select number of threads, on XeonPhi
  for(int i=0;i<s;i++) //s steps are carried out
  {
//    update(n,vi,vf); //the vector is updated and the result is in vf
//#pragma omp parallel for private(pos) schedule(dynamic,1)
  for(pos=0;pos<n;pos++)
  {
//    updateone(n,vi,vf,i); //update one position
  vf[pos]=vi[pos];
  float vtemp=(vi[pos]>0.?vi[pos]:(-1.)*vi[pos]);
  int ld=(int) (vtemp)/100+2;
  for(int j=pos+ld;j<n;j+=ld)
    vf[pos]+=vi[j];
  for(int j=pos-ld;j>=0;j-=ld)
    vf[pos]+=vi[j];
#ifdef DEBUGSEC
    cout << "Step " << i << " Vector ";
    escribir(n,vf);
#endif
  }
#pragma omp barrier
  for(int j=0;j<n;j++)
    vi[j]=vf[j];
}
#ifdef DEBUGSEC
    cout << "Final vector before exiting sec ";
    escribir(n,v);
#endif
  for(int j=0;j<n;j++)
    v[j]=vf[j];
  delete[] vi;
  delete[] vf;
}

