/*
  CPP_CONTEST=2017ClaA
  CPP_PROBLEM=F
  CPP_LANG=CPP+OPENMP+MPI
  CPP_PROCESSES_PER_NODE=12
  CPP_NUM_NODES=1
*/

// 2

#include <stdlib.h>
#include <stdio.h>
#include <omp.h>
#include <iostream>
#include <iomanip>    
#include <math.h>

using namespace std;

#ifdef DEBUG
extern void escribirvector(int,int*);
#endif

int elementinposition(int *a,int izq,int der,int pos)
{
  int i,j,t;
  int piv=a[izq];

  i=izq+1;
  j=der;
  while(i<=j)
  {
    while(i<=der && a[i]<=piv)
    {
      i++;
    }
    while(j>izq && a[j]>piv)
    {
      j--;
    }
    if(i<j)
    {
      t=a[i];
      a[i]=a[j];
      a[j]=t;
    }
  }
  a[izq]=a[j];
  a[j]=piv;
  if(j==pos)
  {
    return a[j];
  }
  else if(j>pos)
  {
    return elementinposition(a,izq,j-1,pos);
  }
  else if(j>=izq && j<pos)
  {
    return elementinposition(a,j+1,der,pos);
  }
}
 
void  sec(int n,int *m,int *v,int np,int node)
{
  int *med=new int[n]; //vector of medians

//Obtain the median of each row
  for(int i=0;i<n;i++) 
  {
    med[i]=elementinposition(&m[i*n],0,n-1,n/2);
  }
#ifdef DEBUG
  escribirvector(n,med);
#endif
//Obtain multiples of the medians
  for(int i=0;i<n;i++)
  {
    int data=med[i];
    v[i]=0;
    if(data!=0 and data!=1 and data!=-1)
    {
       for(int j=0;j<n;j++)
      {
        for(int k=0;k<n;k++)
        {
           if(m[j*n+k]%data==0)
             v[i]++;
        }
      }
    }
    else if(data==1 or data==-1)
      v[i]=n*n;
  }
#ifdef DEBUG
  escribirvector(n,v);
#endif
  delete[] med;
}

